#include "stdio.h"
#include "string.h"
#include "math.h"
#include "time.h"
#include "X11/Intrinsic.h"
#include "X11/Xlib.h"
#include "X11/Xutil.h"
#include "X11/Shell.h"
#include "Xm/Xm.h"
#include "Xm/Form.h"
#include "Xm/MainW.h"
#include "Xm/DrawingA.h"

void key_press();
/***************************/

main(argc, argv)
     int argc;
     char *argv[];
{
  Arg
    args[15];
  int
    nargs;
  Widget
    textbox,
    main,
    form,
    draw;
  Display
    *display;
  XtAppContext
    theAppContext;

/**************************/
XtToolkitInitialize();
theAppContext = XtCreateApplicationContext();
display = XtOpenDisplay(theAppContext, NULL, argv[0], "readkey", NULL, 0,
			(Cardinal *) &argc, argv);
if (display == NULL)
  {
    fprintf(stderr, "Unable to open requested display. Aborting\n");
    exit(0);
  }
textbox = XtAppCreateShell("ReadKey", "ReadKey",
			    applicationShellWidgetClass, display, NULL, 0);

nargs = 0;
XtSetArg(args[nargs], XmNscrollingPolicy, XmAPPLICATION_DEFINED); ++nargs;
main = XmCreateMainWindow(textbox, "main", (ArgList) args, nargs);
XtManageChild(main);

nargs = 0;
XtSetArg(args[nargs], XmNwidth, 300); ++nargs;
XtSetArg(args[nargs], XmNheight, 200); ++nargs;
XtSetArg(args[nargs], XmNresizeWidth, False); ++nargs;
XtSetArg(args[nargs], XmNresizeHeight, False); ++nargs;
form = XmCreateForm(main, "draw form", args, nargs);
XtManageChild(form);

nargs = 0;
XtSetArg(args[nargs], XmNborderWidth, 0); ++nargs;
XtSetArg(args[nargs], XmNtopAttachment, XmATTACH_FORM); ++nargs;
XtSetArg(args[nargs], XmNrightAttachment, XmATTACH_FORM); ++nargs;
XtSetArg(args[nargs], XmNbottomAttachment, XmATTACH_FORM); ++nargs;
XtSetArg(args[nargs], XmNleftAttachment, XmATTACH_FORM); ++nargs;
draw = XmCreateDrawingArea(form, "draw area", args, nargs);
XtManageChild(draw);

XtRealizeWidget(textbox);
XtAddCallback(draw, XmNinputCallback, key_press, NULL);
XtAppMainLoop(theAppContext);
}

/***************************/
void key_press(w, client_data, call_data)
     Widget
       w;
     caddr_t
       client_data,
       call_data;
{
  XmDrawingAreaCallbackStruct
    *theCallback;
  XEvent
    *theEvent;
  XKeyEvent
    *keyEvent;
  KeySym
    keysym;
  char
    KeyBuf[6];

theCallback = (XmDrawingAreaCallbackStruct *) call_data;
theEvent = theCallback->event;
if (theEvent->type != KeyPress) /* not interested, return */
  return;
keyEvent = (XKeyEvent *) theEvent;
XLookupString(keyEvent, KeyBuf, 4, &keysym, NULL);
printf("pressed %d\n", keysym);
}
